# Class TwinfinityIfcMeshExtension

Additional data that decorates Mesh instances with geometry that represents IFC objects.

##### Index

### Constructors

constructor

### Properties

cullingDistance
cullOnCameraMove
indiceCount
isTransparent
primitiveCount
productsAndMeshes

### Methods

dispose
distanceToCamera
isVisible

## Constructors

### constructor

- new TwinfinityIfcMeshExtension(
  _mesh: Mesh,
  _materials: Materials,
  geometry3D: Geometry3d,
  ): TwinfinityIfcMeshExtension

  Constructor

  #### Parameters

  - _mesh: Mesh

    Mesh instance to connect the extension to.

  - _materials: Materials

    Materials instance

  - geometry3D: Geometry3d

    Geometry3dHandle instance representing the geometry which will be applied to `_mesh`.

  #### Returns TwinfinityIfcMeshExtension

## Properties

### `Readonly` cullingDistance

cullingDistance: number

Distance from camera where `_mesh` will become visibile. If < 0 it is always visible.

### cullOnCameraMove

cullOnCameraMove: boolean

### `Readonly` indiceCount

indiceCount: number

Number of indices this Mesh contains.

### `Readonly` isTransparent

isTransparent: boolean

`true` if this Mesh contains transparent objects (in which case it cannot contain opaque objects and `false` if it does)

### `Readonly` primitiveCount

primitiveCount: number

Number of vertices, uv's and normals this Mesh contains.

### `Readonly` productsAndMeshes

productsAndMeshes: BimIfcProductsAndMeshes

All BimIfcObject's and their BimProductMesh'es that makes up the Mesh geometry.'

## Methods

### dispose

- dispose(): void

  #### Returns void

### distanceToCamera

- distanceToCamera(camera: Camera): number

  Gets the distance from an mesh to the camera

  #### Parameters

  - camera: Camera

    Camera to use when checking distance

  #### Returns number

### isVisible

- isVisible(camera: Camera, distance?: number): boolean

  `true` if visible from the supplied cameras point of view. Otherwise `false`.

  #### Parameters

  - camera: Camera

    Camera to use when checking visibility

  - `Optional` distance: number

  #### Returns boolean